"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformDeleteExpressionStatement = exports.transformDeleteExpression = void 0;
const ts = require("typescript");
const lua = require("../../LuaAST");
const utils_1 = require("../../utils");
const lua_ast_1 = require("../utils/lua-ast");
exports.transformDeleteExpression = (node, context) => {
    const lhs = utils_1.cast(context.transformExpression(node.expression), lua.isAssignmentLeftHandSideExpression);
    const assignment = lua.createAssignmentStatement(lhs, lua.createNilLiteral(), node);
    return lua_ast_1.createImmediatelyInvokedFunctionExpression([assignment], [lua.createBooleanLiteral(true)], node);
};
function transformDeleteExpressionStatement(context, node) {
    const expression = ts.isExpressionStatement(node) ? node.expression : node;
    if (ts.isDeleteExpression(expression)) {
        return lua.createAssignmentStatement(utils_1.cast(context.transformExpression(expression.expression), lua.isAssignmentLeftHandSideExpression), lua.createNilLiteral(), expression);
    }
}
exports.transformDeleteExpressionStatement = transformDeleteExpressionStatement;
//# sourceMappingURL=delete.js.map